/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000 Sakai Hiroaki.                              */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Disp 饹Υ饤֥()                                     */
/*****************************************************************************/

#ifndef _NADAR_CLIENT_DISP_H_INCLUDED_
#define _NADAR_CLIENT_DISP_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

typedef struct _Disp * Disp; /* Display 饹 */

/*****************************************************************************/
/* إåեΥ󥯥롼                                              */
/*****************************************************************************/

#include <signal.h>

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/xpm.h>

#include "configure.h"

#include "etc.h"
#include "Substance.h"
#include "Client.h"
#include "Stage.h"
#include "Map.h"
#include "Tank.h"
#include "Canon.h"
#include "Missile.h"
#include "Explosion.h"

#define DISP_NO_PRESS       0
#define DISP_UP_PRESS       1
#define DISP_DOWN_PRESS     2
#define DISP_LEFT_PRESS     4
#define DISP_RIGHT_PRESS    8
#define DISP_BUTTON1_PRESS 16
#define DISP_BUTTON2_PRESS 32
#define DISP_BUTTON3_PRESS 64

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

int DispGetKeyPress(Disp disp);
int DispClearKeyPress(Disp disp);

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Disp DispCreate(int * argcp, char * argv[], int ratio);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Disp DispDestroy(Disp disp);

/*---------------------------------------------------------------------------*/
/*                                                                   */
/*---------------------------------------------------------------------------*/

void DispStart(Disp disp, int (*func)(), void * proc_data);

/*===========================================================================*/
/* Ѵؿ                                                                */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ǥץ쥤Υꥢ                                                      */
/*---------------------------------------------------------------------------*/

int DispClearDisplay(Disp disp);

/*---------------------------------------------------------------------------*/
/*  ԥåޥåפ                                                     */
/*---------------------------------------------------------------------------*/

int DispDrawPixmap(Disp disp, int x, int y, int width, int height,
		   Pixmap pixmap, GC color_mask, int f);

/*---------------------------------------------------------------------------*/
/* ޥåץ饯                                                    */
/*---------------------------------------------------------------------------*/

int DispDrawMap(Disp disp, int x, int y, int state);

/*---------------------------------------------------------------------------*/
/* ֤                                                                */
/*---------------------------------------------------------------------------*/

int DispDrawTank(Disp disp, double x, double y, int angle, int color_number);

/*---------------------------------------------------------------------------*/
/* ˤƤ                                                                */
/*---------------------------------------------------------------------------*/

int DispDrawCanon(Disp disp, double x, double y);

/*---------------------------------------------------------------------------*/
/* ߥ                                                            */
/*---------------------------------------------------------------------------*/

int DispDrawMissile(Disp disp, double x, double y);

/*---------------------------------------------------------------------------*/
/* ȯ                                                                */
/*---------------------------------------------------------------------------*/

int DispDrawExplosion(Disp disp, double x, double y, int radius);

/*---------------------------------------------------------------------------*/
/* եå                                                                */
/*---------------------------------------------------------------------------*/

int DispFlush(Disp disp);

/*---------------------------------------------------------------------------*/
/* 褷饯κ                                                  */
/*---------------------------------------------------------------------------*/

int DispCleanGamePixmap(Disp disp);

/*---------------------------------------------------------------------------*/
/* ǥץ쥤򥳥ԡ                                                  */
/*---------------------------------------------------------------------------*/

int DispDrawDisplay(Disp disp, double x, double y);

/*---------------------------------------------------------------------------*/
/* ƥȤΥꥢ                                                          */
/*---------------------------------------------------------------------------*/

int DispClearText(Disp disp);

/*---------------------------------------------------------------------------*/
/* ƥȤ                                                            */
/*---------------------------------------------------------------------------*/

int DispDrawText(Disp disp, int color_number, char * string);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_CLIENT_DISP_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
